Index: kernel/arch/amd64/src/debugger.c
===================================================================
--- kernel/arch/amd64/src/debugger.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/amd64/src/debugger.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,421 @@
+/*
+ * Copyright (c) 2006 Ondrej Palkovsky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup amd64debug
+ * @{
+ */
+/** @file
+ */
+
+#include <arch/debugger.h>
+#include <console/kconsole.h>
+#include <console/cmd.h>
+#include <print.h>
+#include <panic.h>
+#include <interrupt.h>
+#include <arch/asm.h>
+#include <arch/cpu.h>
+#include <debug.h>
+#include <func.h>
+#include <smp/ipi.h>
+#include <symtab.h>
+
+#ifdef __64_BITS__
+	#define getip(x)  ((x)->rip)
+#endif
+
+#ifdef __32_BITS__
+	#define getip(x)  ((x)->eip)
+#endif
+
+typedef struct  {
+	uintptr_t address;   /**< Breakpoint address */
+	unsigned int flags;  /**< Flags regarding breakpoint */
+	size_t counter;      /**< How many times the exception occured */
+} bpinfo_t;
+
+static bpinfo_t breakpoints[BKPOINTS_MAX];
+IRQ_SPINLOCK_STATIC_INITIALIZE(bkpoint_lock);
+
+#ifdef CONFIG_KCONSOLE
+
+static int cmd_print_breakpoints(cmd_arg_t *);
+static int cmd_del_breakpoint(cmd_arg_t *);
+static int cmd_add_breakpoint(cmd_arg_t *);
+
+static cmd_info_t bkpts_info = {
+	.name = "bkpts",
+	.description = "Print breakpoint table.",
+	.func = cmd_print_breakpoints,
+	.argc = 0,
+};
+
+static cmd_arg_t del_argv = {
+	.type = ARG_TYPE_INT
+};
+
+static cmd_info_t delbkpt_info = {
+	.name = "delbkpt",
+	.description = "Delete breakpoint.",
+	.func = cmd_del_breakpoint,
+	.argc = 1,
+	.argv = &del_argv
+};
+
+static cmd_arg_t add_argv = {
+	.type = ARG_TYPE_INT
+};
+
+static cmd_info_t addbkpt_info = {
+	.name = "addbkpt",
+	.description = "Add breakpoint.",
+	.func = cmd_add_breakpoint,
+	.argc = 1,
+	.argv = &add_argv
+};
+
+static cmd_arg_t addw_argv = {
+	.type = ARG_TYPE_INT
+};
+
+static cmd_info_t addwatchp_info = {
+	.name = "addwatchp",
+	.description = "Add write watchpoint.",
+	.func = cmd_add_breakpoint,
+	.argc = 1,
+	.argv = &addw_argv
+};
+
+#endif /* CONFIG_KCONSOLE */
+
+/** Setup DR register according to table
+ *
+ */
+static void setup_dr(int curidx)
+{
+	ASSERT(curidx >= 0);
+	
+	bpinfo_t *cur = &breakpoints[curidx];
+	unsigned int flags = breakpoints[curidx].flags;
+	
+	/* Disable breakpoint in DR7 */
+	sysarg_t dr7 = read_dr7();
+	dr7 &= ~(0x02U << (curidx * 2));
+	
+	/* Setup DR register */
+	if (cur->address) {
+		/* Set breakpoint to debug registers */
+		switch (curidx) {
+		case 0:
+			write_dr0(cur->address);
+			break;
+		case 1:
+			write_dr1(cur->address);
+			break;
+		case 2:
+			write_dr2(cur->address);
+			break;
+		case 3:
+			write_dr3(cur->address);
+			break;
+		}
+		
+		/* Set type to requested breakpoint & length*/
+		dr7 &= ~(0x03U << (16 + 4 * curidx));
+		dr7 &= ~(0x03U << (18 + 4 * curidx));
+		
+		if (!(flags & BKPOINT_INSTR)) {
+#ifdef __32_BITS__
+			dr7 |= ((sysarg_t) 0x03U) << (18 + 4 * curidx);
+#endif
+			
+#ifdef __64_BITS__
+			dr7 |= ((sysarg_t) 0x02U) << (18 + 4 * curidx);
+#endif
+			
+			if ((flags & BKPOINT_WRITE))
+				dr7 |= ((sysarg_t) 0x01U) << (16 + 4 * curidx);
+			else if ((flags & BKPOINT_READ_WRITE))
+				dr7 |= ((sysarg_t) 0x03U) << (16 + 4 * curidx);
+		}
+		
+		/* Enable global breakpoint */
+		dr7 |= 0x02U << (curidx * 2);
+		
+		write_dr7(dr7);
+	}
+}
+
+/** Enable hardware breakpoint
+ *
+ * @param where Address of HW breakpoint
+ * @param flags Type of breakpoint (EXECUTE, WRITE)
+ *
+ * @return Debug slot on success, -1 - no available HW breakpoint
+ *
+ */
+int breakpoint_add(const void *where, const unsigned int flags, int curidx)
+{
+	ASSERT(flags & (BKPOINT_INSTR | BKPOINT_WRITE | BKPOINT_READ_WRITE));
+	
+	irq_spinlock_lock(&bkpoint_lock, true);
+	
+	if (curidx == -1) {
+		/* Find free space in slots */
+		unsigned int i;
+		for (i = 0; i < BKPOINTS_MAX; i++) {
+			if (!breakpoints[i].address) {
+				curidx = i;
+				break;
+			}
+		}
+		
+		if (curidx == -1) {
+			/* Too many breakpoints */
+			irq_spinlock_unlock(&bkpoint_lock, true);
+			return -1;
+		}
+	}
+	
+	bpinfo_t *cur = &breakpoints[curidx];
+	
+	cur->address = (uintptr_t) where;
+	cur->flags = flags;
+	cur->counter = 0;
+	
+	setup_dr(curidx);
+	
+	irq_spinlock_unlock(&bkpoint_lock, true);
+	
+	/* Send IPI */
+//	ipi_broadcast(VECTOR_DEBUG_IPI);
+	
+	return curidx;
+}
+
+static void handle_exception(int slot, istate_t *istate)
+{
+	ASSERT(slot >= 0);
+	ASSERT(breakpoints[slot].address);
+	
+	/* Handle zero checker */
+	if (!(breakpoints[slot].flags & BKPOINT_INSTR)) {
+		if ((breakpoints[slot].flags & BKPOINT_CHECK_ZERO)) {
+			if (*((sysarg_t *) breakpoints[slot].address) != 0)
+				return;
+			
+			printf("*** Found ZERO on address %p (slot %d) ***\n",
+			    (void *) breakpoints[slot].address, slot);
+		} else {
+			printf("Data watchpoint - new data: %#" PRIxn "\n",
+			    *((sysarg_t *) breakpoints[slot].address));
+		}
+	}
+	
+	printf("Reached breakpoint %d:%p (%s)\n", slot,
+	    (void *) getip(istate), symtab_fmt_name_lookup(getip(istate)));
+	
+#ifdef CONFIG_KCONSOLE
+	atomic_set(&haltstate, 1);
+	kconsole("debug", "Debug console ready.\n", false);
+	atomic_set(&haltstate, 0);
+#endif
+}
+
+void breakpoint_del(int slot)
+{
+	ASSERT(slot >= 0);
+	
+	irq_spinlock_lock(&bkpoint_lock, true);
+	
+	bpinfo_t *cur = &breakpoints[slot];
+	if (!cur->address) {
+		irq_spinlock_unlock(&bkpoint_lock, true);
+		return;
+	}
+	
+	cur->address = (uintptr_t) NULL;
+	
+	setup_dr(slot);
+	
+	irq_spinlock_unlock(&bkpoint_lock, true);
+//	ipi_broadcast(VECTOR_DEBUG_IPI);
+}
+
+static void debug_exception(unsigned int n __attribute__((unused)), istate_t *istate)
+{
+	/* Set RF to restart the instruction  */
+#ifdef __64_BITS__
+	istate->rflags |= RFLAGS_RF;
+#endif
+	
+#ifdef __32_BITS__
+	istate->eflags |= EFLAGS_RF;
+#endif
+	
+	sysarg_t dr6 = read_dr6();
+	
+	unsigned int i;
+	for (i = 0; i < BKPOINTS_MAX; i++) {
+		if (dr6 & (1 << i)) {
+			dr6 &= ~ (1 << i);
+			write_dr6(dr6);
+			
+			handle_exception(i, istate);
+		}
+	}
+}
+
+#ifdef CONFIG_SMP
+static void debug_ipi(unsigned int n __attribute__((unused)),
+    istate_t *istate __attribute__((unused)))
+{
+	irq_spinlock_lock(&bkpoint_lock, false);
+	
+	unsigned int i;
+	for (i = 0; i < BKPOINTS_MAX; i++)
+		setup_dr(i);
+	
+	irq_spinlock_unlock(&bkpoint_lock, false);
+}
+#endif /* CONFIG_SMP */
+
+/** Initialize debugger
+ *
+ */
+void debugger_init()
+{
+	unsigned int i;
+	for (i = 0; i < BKPOINTS_MAX; i++)
+		breakpoints[i].address = (uintptr_t) NULL;
+	
+#ifdef CONFIG_KCONSOLE
+	cmd_initialize(&bkpts_info);
+	if (!cmd_register(&bkpts_info))
+		printf("Cannot register command %s\n", bkpts_info.name);
+	
+	cmd_initialize(&delbkpt_info);
+	if (!cmd_register(&delbkpt_info))
+		printf("Cannot register command %s\n", delbkpt_info.name);
+	
+	cmd_initialize(&addbkpt_info);
+	if (!cmd_register(&addbkpt_info))
+		printf("Cannot register command %s\n", addbkpt_info.name);
+	
+	cmd_initialize(&addwatchp_info);
+	if (!cmd_register(&addwatchp_info))
+		printf("Cannot register command %s\n", addwatchp_info.name);
+#endif /* CONFIG_KCONSOLE */
+	
+	exc_register(VECTOR_DEBUG, "debugger", true,
+	    debug_exception);
+	
+#ifdef CONFIG_SMP
+	exc_register(VECTOR_DEBUG_IPI, "debugger_smp", true,
+	    debug_ipi);
+#endif /* CONFIG_SMP */
+}
+
+#ifdef CONFIG_KCONSOLE
+/** Print table of active breakpoints
+ *
+ */
+int cmd_print_breakpoints(cmd_arg_t *argv __attribute__((unused)))
+{
+#ifdef __32_BITS__
+	printf("[nr] [count] [address ] [in symbol\n");
+#endif
+	
+#ifdef __64_BITS__
+	printf("[nr] [count] [address         ] [in symbol\n");
+#endif
+	
+	unsigned int i;
+	for (i = 0; i < BKPOINTS_MAX; i++) {
+		if (breakpoints[i].address) {
+			const char *symbol = symtab_fmt_name_lookup(
+			    breakpoints[i].address);
+			
+#ifdef __32_BITS__
+			printf("%-4u %7zu %p %s\n", i,
+			    breakpoints[i].counter, (void *) breakpoints[i].address,
+			    symbol);
+#endif
+			
+#ifdef __64_BITS__
+			printf("%-4u %7zu %p %s\n", i,
+			    breakpoints[i].counter, (void *) breakpoints[i].address,
+			    symbol);
+#endif
+		}
+	}
+	
+	return 1;
+}
+
+/** Remove breakpoint from table
+ *
+ */
+int cmd_del_breakpoint(cmd_arg_t *argv)
+{
+	sysarg_t bpno = argv->intval;
+	if (bpno > BKPOINTS_MAX) {
+		printf("Invalid breakpoint number.\n");
+		return 0;
+	}
+	
+	breakpoint_del(argv->intval);
+	return 1;
+}
+
+/** Add new breakpoint to table
+ *
+ */
+static int cmd_add_breakpoint(cmd_arg_t *argv)
+{
+	unsigned int flags;
+	if (argv == &add_argv)
+		flags = BKPOINT_INSTR;
+	else
+		flags = BKPOINT_WRITE;
+	
+	printf("Adding breakpoint on address: %p\n",
+	    (void *) argv->intval);
+	
+	int id = breakpoint_add((void *) argv->intval, flags, -1);
+	if (id < 0)
+		printf("Add breakpoint failed.\n");
+	else
+		printf("Added breakpoint %d.\n", id);
+	
+	return 1;
+}
+#endif /* CONFIG_KCONSOLE */
+
+/** @}
+ */
Index: kernel/arch/amd64/src/fpu_context.c
===================================================================
--- kernel/arch/amd64/src/fpu_context.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/amd64/src/fpu_context.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -57,6 +57,4 @@
 {
 	/* TODO: Zero all SSE, MMX etc. registers */
-	/* Default value of SCR register is 0x1f80,
-	 * it masks all FPU exceptions*/
 	asm volatile (
 		"fninit\n"
Index: kernel/arch/amd64/src/mm/page.c
===================================================================
--- kernel/arch/amd64/src/mm/page.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/amd64/src/mm/page.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -92,5 +92,8 @@
 		access = PF_ACCESS_READ;
 	
-	as_page_fault(page, access, istate);
+	if (as_page_fault(page, access, istate) == AS_PF_FAULT) {
+		fault_if_from_uspace(istate, "Page fault: %p.", (void *) page);
+		panic_memtrap(istate, access, page, NULL);
+	}
 }
 
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/Makefile.inc	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -33,11 +33,5 @@
 ATSIGN = %
 
-GCC_CFLAGS += -fno-omit-frame-pointer -mapcs-frame -march=$(subst _,-,$(PROCESSOR_ARCH)) -mno-unaligned-access
-
-ifeq ($(CONFIG_FPU),y)
-# This is necessary to allow vmsr insn and fpexc manipulation
-# Use vfp32 to allow context save/restore of d16-d31 regs.
-AFLAGS += -mfloat-abi=hard -mfpu=vfp3
-endif
+GCC_CFLAGS += -march=armv4 -fno-omit-frame-pointer -mapcs-frame
 
 BITS = 32
@@ -68,11 +62,10 @@
 	arch/$(KARCH)/src/ras.c
 
-ifeq ($(CONFIG_FPU),y)
-	ARCH_SOURCES +=	arch/$(KARCH)/src/fpu_context.c
-	ARCH_SOURCES +=	arch/$(KARCH)/src/fpu.s
+ifeq ($(MACHINE),gta02)
+	ARCH_SOURCES += arch/$(KARCH)/src/mach/gta02/gta02.c
 endif
 
-ifeq ($(MACHINE),gta02)
-	ARCH_SOURCES += arch/$(KARCH)/src/mach/gta02/gta02.c
+ifeq ($(MACHINE),testarm)
+	ARCH_SOURCES += arch/$(KARCH)/src/mach/testarm/testarm.c
 endif
 
@@ -81,12 +74,4 @@
 endif
 
-ifeq ($(MACHINE),beagleboardxm)
-	ARCH_SOURCES += arch/$(KARCH)/src/mach/beagleboardxm/beagleboardxm.c
-endif
-
-ifeq ($(MACHINE),beaglebone)
-        ARCH_SOURCES += arch/$(KARCH)/src/mach/beaglebone/beaglebone.c
-endif
-
 ifeq ($(CONFIG_PL050),y)
 	ARCH_SOURCES += genarch/src/drivers/pl050/pl050.c
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/_link.ld.in	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -9,8 +9,4 @@
 #ifdef MACHINE_gta02
 #define KERNEL_LOAD_ADDRESS 0xb0a08000
-#elif defined MACHINE_beagleboardxm
-#define KERNEL_LOAD_ADDRESS 0x80a00000
-#elif defined MACHINE_beaglebone
-#define KERNEL_LOAD_ADDRESS 0x80a00000
 #else
 #define KERNEL_LOAD_ADDRESS 0x80a00000
Index: kernel/arch/arm32/include/arch/asm.h
===================================================================
--- kernel/arch/arm32/include/arch/asm.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/asm.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -43,23 +43,7 @@
 #include <trace.h>
 
-/** CPU specific way to sleep cpu.
- *
- * ARMv7 introduced wait for event and wait for interrupt (wfe/wfi).
- * ARM920T has custom coprocessor action to do the same. See ARM920T Technical
- * Reference Manual ch 4.9 p. 4-23 (103 in the PDF)
- * ARM926EJ-S uses the same coprocessor instruction as ARM920T. See ARM926EJ-S
- * chapter 2.3.8 p.2-22 (52 in the PDF)
- *
- * @note Although mcr p15, 0, R0, c7, c0, 4 is defined in ARM Architecture
- * reference manual for armv4/5 CP15 implementation is mandatory only for
- * armv6+.
- */
+/** No such instruction on ARM to sleep CPU. */
 NO_TRACE static inline void cpu_sleep(void)
 {
-#ifdef PROCESSOR_ARCH_armv7_a
-	asm volatile ( "wfe" );
-#elif defined(PROCESSOR_ARCH_armv6) | defined(PROCESSOR_arm926ej_s) | defined(PROCESSOR_arm920t)
-	asm volatile ( "mcr p15, 0, R0, c7, c0, 4" );
-#endif
 }
 
Index: kernel/arch/arm32/include/arch/barrier.h
===================================================================
--- kernel/arch/arm32/include/arch/barrier.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/barrier.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,92 +37,16 @@
 #define KERN_arm32_BARRIER_H_
 
-#ifdef KERNEL
-#include <arch/cp15.h>
-#else
-#include <libarch/cp15.h>
-#endif
-
+/*
+ * TODO: implement true ARM memory barriers for macros below.
+ */
 #define CS_ENTER_BARRIER()  asm volatile ("" ::: "memory")
 #define CS_LEAVE_BARRIER()  asm volatile ("" ::: "memory")
 
-#if defined PROCESSOR_ARCH_armv7_a
-/* ARMv7 uses instructions for memory barriers see ARM Architecture reference
- * manual for details:
- * DMB: ch. A8.8.43 page A8-376
- * DSB: ch. A8.8.44 page A8-378
- * See ch. A3.8.3 page A3-148 for details about memory barrier implementation
- * and functionality on armv7 architecture.
- */
-#define memory_barrier()  asm volatile ("dmb" ::: "memory")
-#define read_barrier()    asm volatile ("dsb" ::: "memory")
-#define write_barrier()   asm volatile ("dsb st" ::: "memory")
-#define inst_barrier()    asm volatile ("isb" ::: "memory")
-#elif defined PROCESSOR_ARCH_armv6 | defined KERNEL
-/*
- * ARMv6 introduced user access of the following commands:
- * - Prefetch flush
- * - Data synchronization barrier
- * - Data memory barrier
- * - Clean and prefetch range operations.
- * ARM Architecture Reference Manual version I ch. B.3.2.1 p. B3-4
- */
-/* ARMv6- use system control coprocessor (CP15) for memory barrier instructions.
- * Although at least mcr p15, 0, r0, c7, c10, 4 is mentioned in earlier archs,
- * CP15 implementation is mandatory only for armv6+.
- */
-#define memory_barrier()  CP15DMB_write(0)
-#define read_barrier()    CP15DSB_write(0)
-#define write_barrier()   read_barrier()
-#define inst_barrier()    CP15ISB_write(0)
-#else
-/* Older manuals mention syscalls as a way to implement cache coherency and
- * barriers. See for example ARM Architecture Reference Manual Version D
- * chapter 2.7.4 Prefetching and self-modifying code (p. A2-28)
- */
-// TODO implement on per PROCESSOR basis or via syscalls
 #define memory_barrier()  asm volatile ("" ::: "memory")
 #define read_barrier()    asm volatile ("" ::: "memory")
 #define write_barrier()   asm volatile ("" ::: "memory")
-#define inst_barrier()    asm volatile ("" ::: "memory")
-#endif
 
-/*
- * There are multiple ways ICache can be implemented on ARM machines. Namely
- * PIPT, VIPT, and ASID and VMID tagged VIVT (see ARM Architecture Reference
- * Manual B3.11.2 (p. 1383).  However, CortexA8 Manual states: "For maximum
- * compatibility across processors, ARM recommends that operating systems target
- * the ARMv7 base architecture that uses ASID-tagged VIVT instruction caches,
- * and do not assume the presence of the IVIPT extension. Software that relies
- * on the IVIPT extension might fail in an unpredictable way on an ARMv7
- * implementation that does not include the IVIPT extension." (7.2.6 p. 245).
- * Only PIPT invalidates cache for all VA aliases if one block is invalidated.
- *
- * @note: Supporting ASID and VMID tagged VIVT may need to add ICache
- * maintenance to other places than just smc.
- */
-
-#if defined PROCESSOR_ARCH_armv7_a | defined PROCESSOR_ARCH_armv6 | defined KERNEL
-/* Available on all supported arms,
- * invalidates entire ICache so the written value does not matter. */
-//TODO might be PL1 only on armv5-
-#define smc_coherence(a) \
-do { \
-	DCCMVAU_write((uint32_t)(a));  /* Flush changed memory */\
-	write_barrier();               /* Wait for completion */\
-	ICIALLU_write(0);              /* Flush ICache */\
-	inst_barrier();                /* Wait for Inst refetch */\
-} while (0)
-/* @note: Cache type register is not available in uspace. We would need
- * to export the cache line value, or use syscall for uspace smc_coherence */
-#define smc_coherence_block(a, l) \
-do { \
-	for (uintptr_t addr = (uintptr_t)a; addr < (uintptr_t)a + l; addr += 4)\
-		smc_coherence(addr); \
-} while (0)
-#else
 #define smc_coherence(a)
 #define smc_coherence_block(a, l)
-#endif
-
 
 #endif
Index: kernel/arch/arm32/include/arch/cpu.h
===================================================================
--- kernel/arch/arm32/include/arch/cpu.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/cpu.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,11 +40,8 @@
 #include <arch/asm.h>
 
-enum {
-	ARM_MAX_CACHE_LEVELS = 7,
-};
 
-/** Struct representing ARM CPU identification. */
+/** Struct representing ARM CPU identifiaction. */
 typedef struct {
-	/** Implementor (vendor) number. */
+	/** Implementator (vendor) number. */
 	uint32_t imp_num;
 
@@ -60,13 +57,4 @@
 	/** Revision number. */
 	uint32_t rev_num;
-
-	struct {
-		unsigned ways;
-		unsigned sets;
-		unsigned line_size;
-		unsigned way_shift;
-		unsigned set_shift;
-	} dcache[ARM_MAX_CACHE_LEVELS];
-	unsigned dcache_levels;
 } cpu_arch_t;
 
Index: kernel/arch/arm32/include/arch/cycle.h
===================================================================
--- kernel/arch/arm32/include/arch/cycle.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/cycle.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,4 @@
 
 #include <trace.h>
-#include <arch/cp15.h>
 
 /** Return count of CPU cycles.
@@ -49,14 +48,4 @@
 NO_TRACE static inline uint64_t get_cycle(void)
 {
-#ifdef PROCESSOR_ARCH_armv7_a
-	if ((ID_PFR1_read() & ID_PFR1_GEN_TIMER_EXT_MASK) ==
-	    ID_PFR1_GEN_TIMER_EXT) {
-	    uint32_t low = 0, high = 0;
-	    asm volatile( "MRRC p15, 0, %[low], %[high], c14": [low]"=r"(low), [high]"=r"(high));
-	   return ((uint64_t)high << 32) | low;
-	} else {
-		return (uint64_t)PMCCNTR_read() * 64;
-	}
-#endif
 	return 0;
 }
Index: kernel/arch/arm32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/arm32/include/arch/fpu_context.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/fpu_context.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -31,5 +31,7 @@
  */
 /** @file
- *  @brief FPU context.
+ *  @brief FPU context (not implemented).
+ *
+ *  GXemul doesn't support FPU on its ARM CPU.
  */
 
@@ -39,17 +41,8 @@
 #include <typedefs.h>
 
-#define FPU_CONTEXT_ALIGN    8
+#define FPU_CONTEXT_ALIGN    0
 
-/* ARM Architecture reference manual, p B-1529.
- */
 typedef struct {
-	uint32_t fpexc;
-	uint32_t fpscr;
-	uint32_t s[64];
 } fpu_context_t;
-
-void fpu_setup(void);
-
-bool handle_if_fpu_exception(void);
 
 #endif
Index: kernel/arch/arm32/include/arch/mach/testarm/testarm.h
===================================================================
--- kernel/arch/arm32/include/arch/mach/testarm/testarm.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/arm32/include/arch/mach/testarm/testarm.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,83 @@
+/*
+ * Copyright (c) 2007 Michal Kebrt
+ * Copyright (c) 2009 Vineeth Pillai
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32gxemul GXemul
+ *  @brief GXemul machine specific parts.
+ *  @ingroup arm32
+ * @{
+ */
+/** @file
+ *  @brief GXemul peripheries drivers declarations.
+ */
+
+#ifndef KERN_arm32_testarm_H_
+#define KERN_arm32_testarm_H_
+
+#include <arch/machine_func.h>
+
+/** Size of GXemul IRQ number range (starting from 0) */
+#define GXEMUL_IRQ_COUNT	32
+#define GXEMUL_KBD_IRQ		2
+#define GXEMUL_TIMER_IRQ	4
+
+/** Timer frequency */
+#define GXEMUL_TIMER_FREQ  100
+
+#define GXEMUL_KBD_ADDRESS   0x10000000
+#define GXEMUL_MP_ADDRESS    0x11000000
+#define GXEMUL_FB_ADDRESS    0x12000000
+#define GXEMUL_RTC_ADDRESS   0x15000000
+#define GXEMUL_IRQC_ADDRESS  0x16000000
+
+extern void *gxemul_kbd;
+extern void *gxemul_rtc;
+extern void *gxemul_irqc;
+
+#define GXEMUL_HALT_OFFSET        0x010
+#define GXEMUL_RTC_FREQ_OFFSET    0x100
+#define GXEMUL_MP_MEMSIZE_OFFSET  0x090
+#define GXEMUL_RTC_ACK_OFFSET     0x110
+
+extern void gxemul_init(void);
+extern void gxemul_output_init(void);
+extern void gxemul_input_init(void);
+extern void gxemul_timer_irq_start(void);
+extern void gxemul_cpu_halt(void);
+extern void gxemul_irq_exception(unsigned int, istate_t *);
+extern void gxemul_get_memory_extents(uintptr_t *, size_t *);
+extern void gxemul_frame_init(void);
+extern size_t gxemul_get_irq_count(void);
+extern const char *gxemul_get_platform_name(void);
+
+extern struct arm_machine_ops gxemul_machine_ops;
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/arm32/include/arch/machine_func.h
===================================================================
--- kernel/arch/arm32/include/arch/machine_func.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/machine_func.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -108,6 +108,4 @@
 extern size_t machine_get_irq_count(void);
 
-extern const char * machine_get_platform_name(void);
-
 #endif
 
Index: kernel/arch/arm32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/frame.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/mm/frame.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -47,27 +47,17 @@
 
 #ifdef MACHINE_gta02
-
-#define PHYSMEM_START_ADDR       0x30008000
 #define BOOT_PAGE_TABLE_ADDRESS  0x30010000
-
-#elif defined MACHINE_beagleboardxm
-
-#define PHYSMEM_START_ADDR       0x80000000
-#define BOOT_PAGE_TABLE_ADDRESS  0x80008000
-
-#elif defined MACHINE_beaglebone
-
-#define PHYSMEM_START_ADDR       0x80000000
-#define BOOT_PAGE_TABLE_ADDRESS  0x80008000
-
 #else
-
-#define PHYSMEM_START_ADDR       0x00000000
 #define BOOT_PAGE_TABLE_ADDRESS  0x00008000
-
 #endif
 
 #define BOOT_PAGE_TABLE_START_FRAME     (BOOT_PAGE_TABLE_ADDRESS >> FRAME_WIDTH)
 #define BOOT_PAGE_TABLE_SIZE_IN_FRAMES  (BOOT_PAGE_TABLE_SIZE >> FRAME_WIDTH)
+
+#ifdef MACHINE_gta02
+#define PHYSMEM_START_ADDR	0x30008000
+#else
+#define PHYSMEM_START_ADDR	0x00000000
+#endif
 
 extern void frame_low_arch_init(void);
